SLASH_VANTUSRUNECHECKER1 = '/vrc'
SlashCmdList["VANTUSRUNECHECKER"] = function(msg, editBox)
	check()
end

function check()
	--Error checking
   if not UnitInRaid("player") then
      print("|cff1784d1VRC|r: You are not in a raid group.")
      return
   end

   local hasRune = false
   local runeName

	 --Check which buff the player has
   for i = 1, 40 do
      if UnitBuff("player", i) then
         local name = select(1, UnitBuff("player", i))

         if string.sub(name, 1, 12) == "Vantus Rune:" then
            hasRune = true
            runeName = name
            break
         end
      end
   end

	 --Error checking
   if not hasRune then
      print("|cff1784d1VRC|r: You do not have a vantus rune buff.")
      return
   else
      print("|cff1784d1VRC|r: Checking rune " .. runeName)
   end

   local runelessUnits = {}
   local wrongRunes = {}
	 local maxGroup = getMaxGroupNumber()

	 --Go through each raid  member and sort them into people without and people with different rune buff
	   for i = 1, GetNumGroupMembers() do
	      local unit = 'raid' .. i
	      local unitHasRune = false
	      local unitHasWrongRune = false
				local unitBuff

				local subgroup = select(3, GetRaidRosterInfo(i))

				if subgroup <= maxGroup then
		      for n = 1, 40 do
		         unitBuff = select(1, UnitBuff(unit, n))

		         if unitBuff then

		            if string.sub(unitBuff, 1, 12) == "Vantus Rune:"
		            and unitBuff ~= runeName then
		               unitHasWrongRune = true
		               break
		            end

		            if unitBuff == runeName then
		               unitHasRune = true
		               break
		            end
		         end
		      end

		      local unitName = UnitName(unit)

		      if unitHasWrongRune then
		         table.insert(wrongRunes, {unitName, unitBuff})
		      end

		      if not unitHasRune and not unitHasWrongRune then
		         table.insert(runelessUnits, unitName)
		      end
				end
	   end

	 --Only output if there is actually people without
   if table.getn(runelessUnits) > 0 then
		 	local noRuneOutput = "No vantus rune: "
		 	for i, player in pairs(runelessUnits) do
				if i == 1 then
					noRuneOutput = noRuneOutput .. player
				elseif string.len(noRuneOutput .. player) > 255 then
					SendChatMessage(noRuneOutput, "RAID")
					noRuneOutput = player
				else
					noRuneOutput = noRuneOutput .. ", " .. player
				end
			end

      SendChatMessage(noRuneOutput, "RAID")
   end

   if table.getn(wrongRunes) > 0 then
		 	local wrongRuneOutput = "Different vantus rune: "

		 	for i, info in pairs(wrongRunes) do
			 	info = info[1] .. "(" .. string.sub(info[2], 14) .. ")"
			 	if i == 1 then
				 	wrongRuneOutput = wrongRuneOutput .. info
			 	elseif string.len(wrongRuneOutput .. info) > 255 then
				 	SendChatMessage(wrongRuneOutput, "RAID")
				 	wrongRuneOutput = info
			 	else
				 	wrongRuneOutput = wrongRuneOutput .. ", " .. info
			 	end
		 	end

    	SendChatMessage(wrongRuneOutput, "RAID")
   end

	 if table.getn(wrongRunes) == 0 and table.getn(runelessUnits) == 0 then
		 SendChatMessage('Vantus rune check: everyone has the correct rune =]', "RAID")
	 end
end

function getMaxGroupNumber()
	local _,instance_type,difficulty = GetInstanceInfo()
	if (instance_type == "party" or instance_type == "scenario") and not IsInRaid() then
		return 1
	elseif instance_type ~= "raid" then
		return 8
	elseif difficulty == 8 or difficulty == 1 or difficulty == 2 then
		return 1
	elseif difficulty == 14 or difficulty == 15 then
		return 6
	elseif difficulty == 16 then
		return 4
	elseif difficulty == 3 or difficulty == 5 then
		return 2
	elseif difficulty == 9 then
		return 8
	else
		return 5
	end
end
